type
	PSloupek = ^Sloupek;
	Sloupek = record
		x, y: Integer;
		px, nx: PSloupek;
		py, ny: PSloupek;
	end;

	Seznam = record
		prvni, posledni: PSloupek;
		l: Integer;
	end;

procedure VytiskniPodleX(s: PSloupek);
var
	i: PSloupek;
begin
	i := s;
	while i<>nil do begin
		Writeln(i^.x, ' ', i^.y);
		i := i^.nx;
	end;
end;

procedure VytiskniPodleY(s: PSloupek);
var
	i: PSloupek;
begin
	i := s;
	while i<>nil do begin
		Writeln(i^.x, ' ', i^.y);
		i := i^.ny;
	end;
end;

function NovySloupek(x, y: Integer): PSloupek;
var	r: PSloupek;
begin
	New(r);
	r^.x := x;
	r^.y := y;
	r^.px := nil;
	r^.nx := nil;
	r^.py := nil;
	r^.ny := nil;
	NovySloupek := r;
end;

procedure SpojPodleX(s1, s2: PSloupek);
begin
	if s1 <> nil then begin
		s1^.nx := s2;
		if s2 <> nil then begin
			s2^.px := s1;
		end;
	end;
	if s2 <> nil then begin
		s2^.px := s1;
		if s1 <> nil then begin
			s1^.nx := s2;
		end;
	end;
end;

procedure SpojPodleY(s1, s2: PSloupek);
begin
	if s1 <> nil then begin
		s1^.ny := s2;
		if s2 <> nil then begin
			s2^.py := s1;
		end;
	end;
	if s2 <> nil then begin
		s2^.py := s1;
		if s1 <> nil then begin
			s1^.ny := s2;
		end;
	end;
end;

procedure RozdelPodleXZa(s: PSloupek);
begin
	if s^.nx <> nil then begin
		s^.nx^.px := nil;
		s^.nx := nil;
	end;
end;

procedure RozdelPodleYZa(s: PSloupek);
begin
	if s^.ny <> nil then begin
		s^.ny^.py := nil;
		s^.ny := nil;
	end;
end;

procedure NovySeznam(var s: Seznam);
begin
	s.prvni := nil;
	s.posledni := nil;
	s.l := 0;
end;

procedure PridejDoSeznamuX(var s: Seznam; sl: PSloupek);
begin
	SpojPodleX(s.posledni, sl);
	if s.prvni = nil then s.prvni := sl;
	s.posledni := sl;
	inc(s.l);
end;

procedure PridejDoSeznamuY(var s: Seznam; sl: PSloupek);
begin
	SpojPodleY(s.posledni, sl);
	if s.prvni = nil then s.prvni := sl;
	s.posledni := sl;
	inc(s.l);
end;

function NajdiX(s: PSloupek; i: Integer): PSloupek;
var 
	j: Integer;
	c: PSloupek;
begin
	c := s;
	if i >= 0 then
			for j:=1 to i do begin
				c := c^.nx;
				if c = nil then break;
			end
	else
			for j:=-1 downto i do begin
				c := c^.px;
				if c = nil then break;
			end;
	NajdiX := c;
end;

function NajdiY(s: PSloupek; i: Integer): PSloupek;
var 
	j: Integer;
	c: PSloupek;
begin
	c := s;
	if i >= 0 then
			for j:=1 to i do begin
				if c = nil then break;
				c := c^.ny;
			end
	else
			for j:=-1 downto i do begin
				if c = nil then break;
				c := c^.py;
			end;
	NajdiY := c;
end;

function SeradPodleX(s: PSloupek; l: Integer): PSloupek;
var
	stred, stred_n: PSloupek;
	prvni, druhy: PSloupek;
	i1, i2: PSloupek;
	r: Seznam;
begin
	if l > 1 then begin
		stred := NajdiX(s, l div 2 - 1);
		stred_n := stred^.nx;

		RozdelPodleXZa(stred);
	
		prvni := SeradPodleX(s, l div 2);
		druhy := SeradPodleX(stred_n, l - (l div 2));
		i1 := prvni;
		i2 := druhy;
		NovySeznam(r);
		while (i1<>nil) or (i2<>nil) do begin
			if (i1 <> nil) and (i2 <> nil) then begin
					if (i1^.x <= i2^.x) then begin
						PridejDoSeznamuX(r, i1);
						i1 := i1^.nx;
						continue;
					end;
					if (i2^.x < i1^.x) then begin
						PridejDoSeznamuX(r, i2);
						i2 := i2^.nx;
						continue;
					end;
			end;
			if (i1 = nil) then begin
				PridejDoSeznamuX(r, i2);
				i2 := nil;
				break;
			end;
			if (i2 = nil) then begin
				PridejDoSeznamuX(r, i1);
				i1 := nil;
				break;
			end;
		end;
		SeradPodleX := r.prvni;
	end else begin
		s^.nx := nil;
		s^.px := nil;
		SeradPodleX := s;
	end;
end;

function SeradPodleY(s: PSloupek; l: Integer): PSloupek;
var
	stred, stred_n: PSloupek;
	prvni, druhy: PSloupek;
	i1, i2: PSloupek;
	r: Seznam;
begin
	if l > 1 then begin
		stred := NajdiY(s, l div 2 - 1);
		stred_n := stred^.ny;

		RozdelPodleYZa(stred);
	
		prvni := SeradPodleY(s, l div 2);
		druhy := SeradPodleY(stred_n, l - (l div 2));
		i1 := prvni;
		i2 := druhy;
		NovySeznam(r);
		while (i1<>nil) or (i2<>nil) do begin
			if (i1 <> nil) and (i2 <> nil) then begin
					if (i1^.y <= i2^.y) then begin
						PridejDoSeznamuY(r, i1);
						i1 := i1^.ny;
						continue;
					end;
					if (i2^.y < i1^.y) then begin
						PridejDoSeznamuY(r, i2);
						i2 := i2^.ny;
						continue;
					end;
			end;
			if (i1 = nil) then begin
				PridejDoSeznamuY(r, i2);
				i2 := nil;
				break;
			end;
			if (i2 = nil) then begin
				PridejDoSeznamuY(r, i1);
				i1 := nil;
				break;
			end;
		end;
		SeradPodleY := r.prvni;
	end else begin
		s^.ny := nil;
		s^.py := nil;
		SeradPodleY := s;
	end;
end;



var
	dalsi: PSloupek;
	i: PSloupek;
	n, i: Integer;
	x, y: Integer;
	seznam_x, seznam_y: Seznam;
begin
	ReadLn(n);
	NovySeznam(seznam_x);
	NovySeznam(seznam_y);
	i := n;
	while i >= 1 do begin
		ReadLn(x, y);
		dalsi := NovySloupek(x, y);
		PridejDoSeznamuX(seznam_x, dalsi);
		PridejDoSeznamuY(seznam_y, dalsi);
		Dec(i);
	end;
	Writeln('Pocatek');
	VytiskniPodleX(seznam_x.prvni);

	seznam_x.prvni := SeradPodleX(seznam_x.prvni, seznam_x.l);
	Writeln('Vysledek podle X');
	VytiskniPodleX(seznam_x.prvni);

	seznam_y.prvni := SeradPodleY(seznam_x.prvni, seznam_y.l);
	Writeln('Vysledek podle Y');
	VytiskniPodleX(seznam_y.prvni);
end.
